/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.box.common.comms.impl;

import org.waveprotocol.box.common.comms.ProtocolAuthenticationResult;
import org.waveprotocol.box.common.comms.ProtocolAuthenticationResultUtil;
import org.waveprotocol.wave.communication.Blob;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Pojo implementation of ProtocolAuthenticationResult.
 *
 * Generated from org/waveprotocol/box/common/comms/waveclient-rpc.proto. Do not edit.
 */
public class ProtocolAuthenticationResultImpl implements ProtocolAuthenticationResult {
  public ProtocolAuthenticationResultImpl() {
  }

  public ProtocolAuthenticationResultImpl(ProtocolAuthenticationResult message) {
    copyFrom(message);
  }

  @Override
  public void copyFrom(ProtocolAuthenticationResult message) {
  }

  /** Provided to subclasses to clear all fields, for example when deserializing. */
  protected void reset() {
  }

  @Override
  public boolean equals(Object o) {
    return (o instanceof ProtocolAuthenticationResultImpl) && isEqualTo(o);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o == this) {
      return true;
    } else if (o instanceof ProtocolAuthenticationResult) {
      return ProtocolAuthenticationResultUtil.isEqual(this, (ProtocolAuthenticationResult) o);
    } else {
      return false;
    }
  }

  @Override
  public int hashCode() {
    return ProtocolAuthenticationResultUtil.getHashCode(this);
  }

}