/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.box.common.comms.jso;

import static org.waveprotocol.wave.communication.gwt.JsonHelper.*;
import com.google.gwt.core.client.*;
import org.waveprotocol.box.common.comms.ProtocolAuthenticationResult;
import org.waveprotocol.box.common.comms.ProtocolAuthenticationResultUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.gwt.*;
import org.waveprotocol.wave.communication.json.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Client implementation of ProtocolAuthenticationResult backed by a GWT JavaScriptObject.
 *
 * Generated from org/waveprotocol/box/common/comms/waveclient-rpc.proto. Do not edit.
 */
// We have to use fully-qualified name of the GsonSerializable class here in order to make it
// visible in case of nested classes.
public final class ProtocolAuthenticationResultJsoImpl extends org.waveprotocol.wave.communication.gwt.JsonMessage
    implements ProtocolAuthenticationResult {
  protected ProtocolAuthenticationResultJsoImpl() {
  }

  public static ProtocolAuthenticationResultJsoImpl create() {
    ProtocolAuthenticationResultJsoImpl instance = (ProtocolAuthenticationResultJsoImpl) JsonMessage.createJsonMessage();
    // Force all lists to start with an empty list rather than no property for
    // the list. This is so that the native JS equality works, since (obviously)
    // {} != {"foo": []} while in the context of messages they should be.
    return instance;
  }

  @Override
  public void copyFrom(ProtocolAuthenticationResult message) {
    super.copyFrom((ProtocolAuthenticationResultJsoImpl) message);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o instanceof ProtocolAuthenticationResultJsoImpl) {
      return nativeIsEqualTo(o);
    } else if (o instanceof ProtocolAuthenticationResult) {
      return ProtocolAuthenticationResultUtil.isEqual(this, (ProtocolAuthenticationResult) o);
    } else {
      return false;
    }
  }

}