/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.box.common.comms.jso;

import static org.waveprotocol.wave.communication.gwt.JsonHelper.*;
import com.google.gwt.core.client.*;
import org.waveprotocol.wave.federation.ProtocolHashedVersion;
import org.waveprotocol.wave.federation.jso.ProtocolHashedVersionJsoImpl;
import org.waveprotocol.box.common.comms.ProtocolSubmitResponse;
import org.waveprotocol.box.common.comms.ProtocolSubmitResponseUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.gwt.*;
import org.waveprotocol.wave.communication.json.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Client implementation of ProtocolSubmitResponse backed by a GWT JavaScriptObject.
 *
 * Generated from org/waveprotocol/box/common/comms/waveclient-rpc.proto. Do not edit.
 */
// We have to use fully-qualified name of the GsonSerializable class here in order to make it
// visible in case of nested classes.
public final class ProtocolSubmitResponseJsoImpl extends org.waveprotocol.wave.communication.gwt.JsonMessage
    implements ProtocolSubmitResponse {
  private static final String keyOperationsApplied = "1";
  private static final String keyErrorMessage = "2";
  private static final String keyHashedVersionAfterApplication = "3";
  protected ProtocolSubmitResponseJsoImpl() {
  }

  public static ProtocolSubmitResponseJsoImpl create() {
    ProtocolSubmitResponseJsoImpl instance = (ProtocolSubmitResponseJsoImpl) JsonMessage.createJsonMessage();
    // Force all lists to start with an empty list rather than no property for
    // the list. This is so that the native JS equality works, since (obviously)
    // {} != {"foo": []} while in the context of messages they should be.
    return instance;
  }

  @Override
  public void copyFrom(ProtocolSubmitResponse message) {
    super.copyFrom((ProtocolSubmitResponseJsoImpl) message);
  }

  @Override
  public int getOperationsApplied() {
    return hasProperty(this, keyOperationsApplied) ? getPropertyAsInteger(this, keyOperationsApplied) : 0;
  }

  @Override
  public void setOperationsApplied(int value) {
    setPropertyAsInteger(this, keyOperationsApplied, value);
  }

  @Override
  public boolean hasErrorMessage() {
    return hasProperty(this, keyErrorMessage);
  }

  @Override
  public void clearErrorMessage() {
    if (hasProperty(this, keyErrorMessage)) {
      deleteProperty(this, keyErrorMessage);
    }
  }

  @Override
  public String getErrorMessage() {
    return hasProperty(this, keyErrorMessage) ? getPropertyAsString(this, keyErrorMessage) : null;
  }

  @Override
  public void setErrorMessage(String value) {
    setPropertyAsString(this, keyErrorMessage, value);
  }

  @Override
  public boolean hasHashedVersionAfterApplication() {
    return hasProperty(this, keyHashedVersionAfterApplication);
  }

  @Override
  public void clearHashedVersionAfterApplication() {
    if (hasProperty(this, keyHashedVersionAfterApplication)) {
      deleteProperty(this, keyHashedVersionAfterApplication);
    }
  }

  @Override
  public ProtocolHashedVersion getHashedVersionAfterApplication() {
    return hasProperty(this, keyHashedVersionAfterApplication) ? ((ProtocolHashedVersionJsoImpl) getPropertyAsObject(this, keyHashedVersionAfterApplication)) : null;
  }

  @Override
  public void setHashedVersionAfterApplication(ProtocolHashedVersion model) {
    setPropertyAsObject(this, keyHashedVersionAfterApplication, (ProtocolHashedVersionJsoImpl) model);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o instanceof ProtocolSubmitResponseJsoImpl) {
      return nativeIsEqualTo(o);
    } else if (o instanceof ProtocolSubmitResponse) {
      return ProtocolSubmitResponseUtil.isEqual(this, (ProtocolSubmitResponse) o);
    } else {
      return false;
    }
  }

}