/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.box.common.comms.proto;

import org.waveprotocol.wave.federation.ProtocolHashedVersion;
import org.waveprotocol.wave.federation.proto.ProtocolHashedVersionProtoImpl;
import org.waveprotocol.box.common.comms.ProtocolSubmitResponse;
import org.waveprotocol.box.common.comms.ProtocolSubmitResponseUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.Codec;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.proto.Int52;
import org.waveprotocol.wave.communication.proto.ProtoWrapper;
import org.waveprotocol.wave.communication.gson.GsonException;
import org.waveprotocol.wave.communication.gson.GsonSerializable;
import org.waveprotocol.wave.communication.gson.GsonUtil;
import org.waveprotocol.wave.communication.json.RawStringData;
import com.google.gson.Gson;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonPrimitive;
import com.google.protobuf.ByteString;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Server implementation of ProtocolSubmitResponse.
 *
 * Generated from org/waveprotocol/box/common/comms/waveclient-rpc.proto. Do not edit.
 */
// NOTE(kalman): It would be nicer to add a proto serialisation
// utility rather than having this class at all.
public final class ProtocolSubmitResponseProtoImpl
    implements ProtocolSubmitResponse,
// Note: fully-qualified path is required for GsonSerializable and ProtoWrapper.
// An import of it is not resolved correctly from inner classes.
// This appears to be a javac bug. The Eclipse compiler handles it fine.
org.waveprotocol.wave.communication.gson.GsonSerializable,
org.waveprotocol.wave.communication.proto.ProtoWrapper<org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse> {
  private org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse proto = null;
  private org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse.Builder protoBuilder = org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse.newBuilder();
  public ProtocolSubmitResponseProtoImpl() {
  }

  public ProtocolSubmitResponseProtoImpl(org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse proto) {
    this.proto = proto;
  }

  public ProtocolSubmitResponseProtoImpl(ProtocolSubmitResponse message) {
    copyFrom(message);
  }

  @Override
  public org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse getPB() {
    switchToProto();
    return proto;
  }

  @Override
  public void setPB(org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse proto) {
    this.proto = proto;
    this.protoBuilder = null;
  }

  @Override
  public void copyFrom(ProtocolSubmitResponse message) {
    setOperationsApplied(message.getOperationsApplied());
    if (message.hasErrorMessage()) {
      setErrorMessage(message.getErrorMessage());
    } else {
      clearErrorMessage();
    }
    if (message.hasHashedVersionAfterApplication()) {
      setHashedVersionAfterApplication(new ProtocolHashedVersionProtoImpl(message.getHashedVersionAfterApplication()));
    } else {
      clearHashedVersionAfterApplication();
    }
  }

  @Override
  public int getOperationsApplied() {
    switchToProto();
    return proto.getOperationsApplied();
  }

  @Override
  public void setOperationsApplied(int value) {
    switchToProtoBuilder();
    protoBuilder.setOperationsApplied(value);
  }

  @Override
  public boolean hasErrorMessage() {
    switchToProto();
    return proto.hasErrorMessage();
  }

  @Override
  public void clearErrorMessage() {
    switchToProtoBuilder();
    protoBuilder.clearErrorMessage();
  }

  @Override
  public String getErrorMessage() {
    switchToProto();
    return proto.getErrorMessage();
  }

  @Override
  public void setErrorMessage(String value) {
    switchToProtoBuilder();
    protoBuilder.setErrorMessage(value);
  }

  @Override
  public boolean hasHashedVersionAfterApplication() {
    switchToProto();
    return proto.hasHashedVersionAfterApplication();
  }

  @Override
  public void clearHashedVersionAfterApplication() {
    switchToProtoBuilder();
    protoBuilder.clearHashedVersionAfterApplication();
  }

  @Override
  public ProtocolHashedVersionProtoImpl getHashedVersionAfterApplication() {
    switchToProto();
    return new ProtocolHashedVersionProtoImpl(proto.getHashedVersionAfterApplication());
  }

  @Override
  public void setHashedVersionAfterApplication(ProtocolHashedVersion value) {
    switchToProtoBuilder();
    protoBuilder.clearHashedVersionAfterApplication();
    protoBuilder.setHashedVersionAfterApplication(getOrCreateProtocolHashedVersionProtoImpl(value).getPB());
  }

  /** Get or create a ProtocolHashedVersionProtoImpl from a ProtocolHashedVersion. */
  private ProtocolHashedVersionProtoImpl getOrCreateProtocolHashedVersionProtoImpl(ProtocolHashedVersion message) {
    if (message instanceof ProtocolHashedVersionProtoImpl) {
      return (ProtocolHashedVersionProtoImpl) message;
    } else {
      ProtocolHashedVersionProtoImpl messageImpl = new ProtocolHashedVersionProtoImpl();
      messageImpl.copyFrom(message);
      return messageImpl;
    }
  }

  private void switchToProto() {
    if (proto == null) {
      proto = protoBuilder.build();
      protoBuilder = null;
    }
  }

  private void switchToProtoBuilder() {
    if (protoBuilder == null) {
      protoBuilder = (proto == null)
          ? org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse.newBuilder()
          : org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse.newBuilder(proto);
      proto = null;
    }
  }

  private void invalidateAll() {
    proto = null;
    protoBuilder = org.waveprotocol.box.common.comms.WaveClientRpc.ProtocolSubmitResponse.newBuilder();
  }

  @Override
  public JsonElement toGson(RawStringData raw, Gson gson) {
    JsonObject json = new JsonObject();
    json.add("1", new JsonPrimitive(getOperationsApplied()));
    if (hasErrorMessage()) {
      json.add("2", new JsonPrimitive(getErrorMessage()));
    }
    if (hasHashedVersionAfterApplication()) {
      {
        JsonElement elem = ((GsonSerializable) getHashedVersionAfterApplication()).toGson(raw, gson);
        json.add("3", elem);
      }
    }
    return json;
  }

  @Override
  public void fromGson(JsonElement json, Gson gson, RawStringData raw) throws GsonException {
    JsonObject jsonObject = json.getAsJsonObject();
    // NOTE: always check with has(...) as the json might not have all required
    // fields set; however these (obviously) will need to be set by other means
    // before accessing this object.
    invalidateAll();
    if (jsonObject.has("1")) {
      JsonElement elem = jsonObject.get("1");
      setOperationsApplied(elem.getAsInt());
    }
    if (jsonObject.has("2")) {
      JsonElement elem = jsonObject.get("2");
      if (!elem.isJsonNull()) {
        setErrorMessage(elem.getAsString());
      }
    }
    if (jsonObject.has("3")) {
      JsonElement elem = jsonObject.get("3");
      if (!elem.isJsonNull()) {
        {
          ProtocolHashedVersionProtoImpl payload = new ProtocolHashedVersionProtoImpl();
          GsonUtil.extractJsonObject(payload, elem, gson, raw);
          setHashedVersionAfterApplication(payload);
        }
      }
    }
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    } else if (o instanceof ProtocolSubmitResponseProtoImpl) {
      return getPB().equals(((ProtocolSubmitResponseProtoImpl) o).getPB());
    } else {
      return false;
    }
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (equals(o)) {
      return true;
    } else if (o instanceof ProtocolSubmitResponse) {
      return ProtocolSubmitResponseUtil.isEqual(this, (ProtocolSubmitResponse) o);
    } else {
      return false;
    }
  }

  @Override
  public int hashCode() {
    return getPB().hashCode();
  }

  @Override
  public String toString() {
    return getPB().toString();
  }

}