/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.box.search.jso;

import static org.waveprotocol.wave.communication.gwt.JsonHelper.*;
import com.google.gwt.core.client.*;
import org.waveprotocol.box.search.SearchRequest;
import org.waveprotocol.box.search.SearchRequestUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.gwt.*;
import org.waveprotocol.wave.communication.json.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Client implementation of SearchRequest backed by a GWT JavaScriptObject.
 *
 * Generated from org/waveprotocol/box/search/search.proto. Do not edit.
 */
// We have to use fully-qualified name of the GsonSerializable class here in order to make it
// visible in case of nested classes.
public final class SearchRequestJsoImpl extends org.waveprotocol.wave.communication.gwt.JsonMessage
    implements SearchRequest {
  private static final String keyQuery = "1";
  private static final String keyIndex = "2";
  private static final String keyNumResults = "3";
  protected SearchRequestJsoImpl() {
  }

  public static SearchRequestJsoImpl create() {
    SearchRequestJsoImpl instance = (SearchRequestJsoImpl) JsonMessage.createJsonMessage();
    // Force all lists to start with an empty list rather than no property for
    // the list. This is so that the native JS equality works, since (obviously)
    // {} != {"foo": []} while in the context of messages they should be.
    return instance;
  }

  @Override
  public void copyFrom(SearchRequest message) {
    super.copyFrom((SearchRequestJsoImpl) message);
  }

  @Override
  public String getQuery() {
    return hasProperty(this, keyQuery) ? getPropertyAsString(this, keyQuery) : null;
  }

  @Override
  public void setQuery(String value) {
    setPropertyAsString(this, keyQuery, value);
  }

  @Override
  public int getIndex() {
    return hasProperty(this, keyIndex) ? getPropertyAsInteger(this, keyIndex) : 0;
  }

  @Override
  public void setIndex(int value) {
    setPropertyAsInteger(this, keyIndex, value);
  }

  @Override
  public int getNumResults() {
    return hasProperty(this, keyNumResults) ? getPropertyAsInteger(this, keyNumResults) : 0;
  }

  @Override
  public void setNumResults(int value) {
    setPropertyAsInteger(this, keyNumResults, value);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o instanceof SearchRequestJsoImpl) {
      return nativeIsEqualTo(o);
    } else if (o instanceof SearchRequest) {
      return SearchRequestUtil.isEqual(this, (SearchRequest) o);
    } else {
      return false;
    }
  }

}