/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.box.server.rpc.impl;

import org.waveprotocol.box.server.rpc.CancelRpc;
import org.waveprotocol.box.server.rpc.CancelRpcUtil;
import org.waveprotocol.wave.communication.Blob;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Pojo implementation of CancelRpc.
 *
 * Generated from org/waveprotocol/box/server/rpc/rpc.proto. Do not edit.
 */
public class CancelRpcImpl implements CancelRpc {
  public CancelRpcImpl() {
  }

  public CancelRpcImpl(CancelRpc message) {
    copyFrom(message);
  }

  @Override
  public void copyFrom(CancelRpc message) {
  }

  /** Provided to subclasses to clear all fields, for example when deserializing. */
  protected void reset() {
  }

  @Override
  public boolean equals(Object o) {
    return (o instanceof CancelRpcImpl) && isEqualTo(o);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o == this) {
      return true;
    } else if (o instanceof CancelRpc) {
      return CancelRpcUtil.isEqual(this, (CancelRpc) o);
    } else {
      return false;
    }
  }

  @Override
  public int hashCode() {
    return CancelRpcUtil.getHashCode(this);
  }

}