/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.wave.concurrencycontrol;

import org.waveprotocol.wave.concurrencycontrol.ResponseStatus.ResponseCode;
import org.waveprotocol.wave.concurrencycontrol.ResponseStatusUtil;
import org.waveprotocol.wave.communication.Blob;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Builder for ResponseStatuss.
 *
 * Generated from org/waveprotocol/wave/concurrencycontrol/clientserver.proto. Do not edit.
 */
public final class ResponseStatusBuilder {

  /** Factory to pass to {@link #build()}. */
  public interface Factory {
    ResponseStatus create();
  }

  private ResponseCode status;
  private String failureReason;
  public ResponseStatusBuilder() {
  }

  public ResponseStatusBuilder setStatus(ResponseCode value) {
    this.status = value;
    return this;
  }

  public ResponseStatusBuilder clearFailureReason() {
    failureReason = null;
    return this;
  }

  public ResponseStatusBuilder setFailureReason(String value) {
    this.failureReason = value;
    return this;
  }

  /** Builds a {@link ResponseStatus} using this builder and a factory. */
  public ResponseStatus build(Factory factory) {
    ResponseStatus message = factory.create();
    message.setStatus(status);
    message.setFailureReason(failureReason);
    return message;
  }

}