/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.wave.concurrencycontrol;

import org.waveprotocol.wave.concurrencycontrol.WaveletChannelTerminator.*;
import org.waveprotocol.wave.concurrencycontrol.ResponseStatus;
import org.waveprotocol.wave.concurrencycontrol.ResponseStatusUtil;
import org.waveprotocol.wave.communication.Blob;
import java.util.Iterator;
import java.util.List;

/**
 * Compares {@link WaveletChannelTerminator}s for equality.
 *
 * Generated from org/waveprotocol/wave/concurrencycontrol/clientserver.proto. Do not edit.
 */
public final class WaveletChannelTerminatorUtil {
  private WaveletChannelTerminatorUtil() {
  }

  /** Returns true if m1 and m2 are structurally equal. */
  public static boolean isEqual(WaveletChannelTerminator m1, WaveletChannelTerminator m2) {
    if (!ResponseStatusUtil.isEqual(m1.getStatus(), m2.getStatus())) return false;
    return true;
  }

  /** Returns true if m1 and m2 are equal according to isEqual. */
  public static boolean areAllEqual(List<? extends WaveletChannelTerminator> m1,
  List<? extends WaveletChannelTerminator> m2) {
    if (m1.size() != m2.size()) return false;
    Iterator<? extends WaveletChannelTerminator> i1 = m1.iterator();
    Iterator<? extends WaveletChannelTerminator> i2 = m2.iterator();
    while (i1.hasNext()) {
      if (!isEqual(i1.next(), i2.next())) return false;
    }
    return true;
  }

  /** Returns a structural hash code of message. */
  public static int getHashCode(WaveletChannelTerminator message) {
    int result = 1;
    result = (31 * result) + message.getStatus().hashCode();
    return result;
  }

}