/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.wave.concurrencycontrol.jso;

import static org.waveprotocol.wave.communication.gwt.JsonHelper.*;
import com.google.gwt.core.client.*;
import org.waveprotocol.wave.concurrencycontrol.ResponseStatus.ResponseCode;
import org.waveprotocol.wave.concurrencycontrol.ResponseStatus;
import org.waveprotocol.wave.concurrencycontrol.ResponseStatusUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.gwt.*;
import org.waveprotocol.wave.communication.json.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Client implementation of ResponseStatus backed by a GWT JavaScriptObject.
 *
 * Generated from org/waveprotocol/wave/concurrencycontrol/clientserver.proto. Do not edit.
 */
// We have to use fully-qualified name of the GsonSerializable class here in order to make it
// visible in case of nested classes.
public final class ResponseStatusJsoImpl extends org.waveprotocol.wave.communication.gwt.JsonMessage
    implements ResponseStatus {
  private static final String keyStatus = "1";
  private static final String keyFailureReason = "2";
  protected ResponseStatusJsoImpl() {
  }

  public static ResponseStatusJsoImpl create() {
    ResponseStatusJsoImpl instance = (ResponseStatusJsoImpl) JsonMessage.createJsonMessage();
    // Force all lists to start with an empty list rather than no property for
    // the list. This is so that the native JS equality works, since (obviously)
    // {} != {"foo": []} while in the context of messages they should be.
    return instance;
  }

  @Override
  public void copyFrom(ResponseStatus message) {
    super.copyFrom((ResponseStatusJsoImpl) message);
  }

  @Override
  public ResponseCode getStatus() {
    return hasProperty(this, keyStatus) ? ProtoEnums.valOf(getPropertyAsInteger(this, keyStatus), ResponseCode.values()) : null;
  }

  @Override
  public void setStatus(ResponseCode enumValue) {
    setPropertyAsInteger(this, keyStatus, enumValue.getValue());
  }

  @Override
  public boolean hasFailureReason() {
    return hasProperty(this, keyFailureReason);
  }

  @Override
  public void clearFailureReason() {
    if (hasProperty(this, keyFailureReason)) {
      deleteProperty(this, keyFailureReason);
    }
  }

  @Override
  public String getFailureReason() {
    return hasProperty(this, keyFailureReason) ? getPropertyAsString(this, keyFailureReason) : null;
  }

  @Override
  public void setFailureReason(String value) {
    setPropertyAsString(this, keyFailureReason, value);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o instanceof ResponseStatusJsoImpl) {
      return nativeIsEqualTo(o);
    } else if (o instanceof ResponseStatus) {
      return ResponseStatusUtil.isEqual(this, (ResponseStatus) o);
    } else {
      return false;
    }
  }

}