/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.wave.concurrencycontrol.jso;

import static org.waveprotocol.wave.communication.gwt.JsonHelper.*;
import com.google.gwt.core.client.*;
import org.waveprotocol.wave.federation.ProtocolWaveletDelta;
import org.waveprotocol.wave.federation.jso.ProtocolWaveletDeltaJsoImpl;
import org.waveprotocol.wave.concurrencycontrol.SubmitDeltaRequest;
import org.waveprotocol.wave.concurrencycontrol.SubmitDeltaRequestUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.gwt.*;
import org.waveprotocol.wave.communication.json.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Client implementation of SubmitDeltaRequest backed by a GWT JavaScriptObject.
 *
 * Generated from org/waveprotocol/wave/concurrencycontrol/clientserver.proto. Do not edit.
 */
// We have to use fully-qualified name of the GsonSerializable class here in order to make it
// visible in case of nested classes.
public final class SubmitDeltaRequestJsoImpl extends org.waveprotocol.wave.communication.gwt.JsonMessage
    implements SubmitDeltaRequest {
  private static final String keyWaveId = "1";
  private static final String keyWaveletId = "2";
  private static final String keyDelta = "3";
  private static final String keyChannelId = "4";
  protected SubmitDeltaRequestJsoImpl() {
  }

  public static SubmitDeltaRequestJsoImpl create() {
    SubmitDeltaRequestJsoImpl instance = (SubmitDeltaRequestJsoImpl) JsonMessage.createJsonMessage();
    // Force all lists to start with an empty list rather than no property for
    // the list. This is so that the native JS equality works, since (obviously)
    // {} != {"foo": []} while in the context of messages they should be.
    return instance;
  }

  @Override
  public void copyFrom(SubmitDeltaRequest message) {
    super.copyFrom((SubmitDeltaRequestJsoImpl) message);
  }

  @Override
  public String getWaveId() {
    return hasProperty(this, keyWaveId) ? getPropertyAsString(this, keyWaveId) : null;
  }

  @Override
  public void setWaveId(String value) {
    setPropertyAsString(this, keyWaveId, value);
  }

  @Override
  public String getWaveletId() {
    return hasProperty(this, keyWaveletId) ? getPropertyAsString(this, keyWaveletId) : null;
  }

  @Override
  public void setWaveletId(String value) {
    setPropertyAsString(this, keyWaveletId, value);
  }

  @Override
  public ProtocolWaveletDelta getDelta() {
    return hasProperty(this, keyDelta) ? ((ProtocolWaveletDeltaJsoImpl) getPropertyAsObject(this, keyDelta)) : null;
  }

  @Override
  public void setDelta(ProtocolWaveletDelta model) {
    setPropertyAsObject(this, keyDelta, (ProtocolWaveletDeltaJsoImpl) model);
  }

  @Override
  public String getChannelId() {
    return hasProperty(this, keyChannelId) ? getPropertyAsString(this, keyChannelId) : null;
  }

  @Override
  public void setChannelId(String value) {
    setPropertyAsString(this, keyChannelId, value);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o instanceof SubmitDeltaRequestJsoImpl) {
      return nativeIsEqualTo(o);
    } else if (o instanceof SubmitDeltaRequest) {
      return SubmitDeltaRequestUtil.isEqual(this, (SubmitDeltaRequest) o);
    } else {
      return false;
    }
  }

}