/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.wave.concurrencycontrol.jso;

import static org.waveprotocol.wave.communication.gwt.JsonHelper.*;
import com.google.gwt.core.client.*;
import org.waveprotocol.wave.concurrencycontrol.TransportAuthenticationRequest;
import org.waveprotocol.wave.concurrencycontrol.TransportAuthenticationRequestUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.gwt.*;
import org.waveprotocol.wave.communication.json.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Client implementation of TransportAuthenticationRequest backed by a GWT JavaScriptObject.
 *
 * Generated from org/waveprotocol/wave/concurrencycontrol/clientserver.proto. Do not edit.
 */
// We have to use fully-qualified name of the GsonSerializable class here in order to make it
// visible in case of nested classes.
public final class TransportAuthenticationRequestJsoImpl extends org.waveprotocol.wave.communication.gwt.JsonMessage
    implements TransportAuthenticationRequest {
  private static final String keyToken = "1";
  protected TransportAuthenticationRequestJsoImpl() {
  }

  public static TransportAuthenticationRequestJsoImpl create() {
    TransportAuthenticationRequestJsoImpl instance = (TransportAuthenticationRequestJsoImpl) JsonMessage.createJsonMessage();
    // Force all lists to start with an empty list rather than no property for
    // the list. This is so that the native JS equality works, since (obviously)
    // {} != {"foo": []} while in the context of messages they should be.
    return instance;
  }

  @Override
  public void copyFrom(TransportAuthenticationRequest message) {
    super.copyFrom((TransportAuthenticationRequestJsoImpl) message);
  }

  @Override
  public String getToken() {
    return hasProperty(this, keyToken) ? getPropertyAsString(this, keyToken) : null;
  }

  @Override
  public void setToken(String value) {
    setPropertyAsString(this, keyToken, value);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o instanceof TransportAuthenticationRequestJsoImpl) {
      return nativeIsEqualTo(o);
    } else if (o instanceof TransportAuthenticationRequest) {
      return TransportAuthenticationRequestUtil.isEqual(this, (TransportAuthenticationRequest) o);
    } else {
      return false;
    }
  }

}