/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.wave.concurrencycontrol.jso;

import static org.waveprotocol.wave.communication.gwt.JsonHelper.*;
import com.google.gwt.core.client.*;
import org.waveprotocol.wave.federation.ProtocolWaveletDelta;
import org.waveprotocol.wave.federation.ProtocolHashedVersion;
import org.waveprotocol.wave.federation.jso.ProtocolWaveletDeltaJsoImpl;
import org.waveprotocol.wave.federation.jso.ProtocolHashedVersionJsoImpl;
import org.waveprotocol.wave.concurrencycontrol.WaveletUpdate;
import org.waveprotocol.wave.concurrencycontrol.WaveletUpdateUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.gwt.*;
import org.waveprotocol.wave.communication.json.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Client implementation of WaveletUpdate backed by a GWT JavaScriptObject.
 *
 * Generated from org/waveprotocol/wave/concurrencycontrol/clientserver.proto. Do not edit.
 */
// We have to use fully-qualified name of the GsonSerializable class here in order to make it
// visible in case of nested classes.
public final class WaveletUpdateJsoImpl extends org.waveprotocol.wave.communication.gwt.JsonMessage
    implements WaveletUpdate {
  private static final String keyDelta = "1";
  private static final String keyResultingVersion = "2";
  private static final String keyApplicationTimpstamp = "3";
  protected WaveletUpdateJsoImpl() {
  }

  public static WaveletUpdateJsoImpl create() {
    WaveletUpdateJsoImpl instance = (WaveletUpdateJsoImpl) JsonMessage.createJsonMessage();
    // Force all lists to start with an empty list rather than no property for
    // the list. This is so that the native JS equality works, since (obviously)
    // {} != {"foo": []} while in the context of messages they should be.
    return instance;
  }

  @Override
  public void copyFrom(WaveletUpdate message) {
    super.copyFrom((WaveletUpdateJsoImpl) message);
  }

  @Override
  public ProtocolWaveletDelta getDelta() {
    return hasProperty(this, keyDelta) ? ((ProtocolWaveletDeltaJsoImpl) getPropertyAsObject(this, keyDelta)) : null;
  }

  @Override
  public void setDelta(ProtocolWaveletDelta model) {
    setPropertyAsObject(this, keyDelta, (ProtocolWaveletDeltaJsoImpl) model);
  }

  @Override
  public ProtocolHashedVersion getResultingVersion() {
    return hasProperty(this, keyResultingVersion) ? ((ProtocolHashedVersionJsoImpl) getPropertyAsObject(this, keyResultingVersion)) : null;
  }

  @Override
  public void setResultingVersion(ProtocolHashedVersion model) {
    setPropertyAsObject(this, keyResultingVersion, (ProtocolHashedVersionJsoImpl) model);
  }

  @Override
  public long getApplicationTimpstamp() {
    return hasProperty(this, keyApplicationTimpstamp) ? getPropertyAsLong(this, keyApplicationTimpstamp) : 0L;
  }

  @Override
  public void setApplicationTimpstamp(long value) {
    setPropertyAsLong(this, keyApplicationTimpstamp, value);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o instanceof WaveletUpdateJsoImpl) {
      return nativeIsEqualTo(o);
    } else if (o instanceof WaveletUpdate) {
      return WaveletUpdateUtil.isEqual(this, (WaveletUpdate) o);
    } else {
      return false;
    }
  }

}