/**
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.waveprotocol.wave.federation.jso;

import static org.waveprotocol.wave.communication.gwt.JsonHelper.*;
import com.google.gwt.core.client.*;
import org.waveprotocol.wave.federation.ProtocolSignedDelta;
import org.waveprotocol.wave.federation.ProtocolHashedVersion;
import org.waveprotocol.wave.federation.jso.ProtocolSignedDeltaJsoImpl;
import org.waveprotocol.wave.federation.jso.ProtocolHashedVersionJsoImpl;
import org.waveprotocol.wave.federation.ProtocolAppliedWaveletDelta;
import org.waveprotocol.wave.federation.ProtocolAppliedWaveletDeltaUtil;
import org.waveprotocol.wave.communication.Blob;
import org.waveprotocol.wave.communication.ProtoEnums;
import org.waveprotocol.wave.communication.gwt.*;
import org.waveprotocol.wave.communication.json.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Client implementation of ProtocolAppliedWaveletDelta backed by a GWT JavaScriptObject.
 *
 * Generated from org/waveprotocol/wave/federation/federation.protodevel. Do not edit.
 */
// We have to use fully-qualified name of the GsonSerializable class here in order to make it
// visible in case of nested classes.
public final class ProtocolAppliedWaveletDeltaJsoImpl extends org.waveprotocol.wave.communication.gwt.JsonMessage
    implements ProtocolAppliedWaveletDelta {
  private static final String keySignedOriginalDelta = "1";
  private static final String keyHashedVersionAppliedAt = "2";
  private static final String keyOperationsApplied = "3";
  private static final String keyApplicationTimestamp = "4";
  protected ProtocolAppliedWaveletDeltaJsoImpl() {
  }

  public static ProtocolAppliedWaveletDeltaJsoImpl create() {
    ProtocolAppliedWaveletDeltaJsoImpl instance = (ProtocolAppliedWaveletDeltaJsoImpl) JsonMessage.createJsonMessage();
    // Force all lists to start with an empty list rather than no property for
    // the list. This is so that the native JS equality works, since (obviously)
    // {} != {"foo": []} while in the context of messages they should be.
    return instance;
  }

  @Override
  public void copyFrom(ProtocolAppliedWaveletDelta message) {
    super.copyFrom((ProtocolAppliedWaveletDeltaJsoImpl) message);
  }

  @Override
  public ProtocolSignedDelta getSignedOriginalDelta() {
    return hasProperty(this, keySignedOriginalDelta) ? ((ProtocolSignedDeltaJsoImpl) getPropertyAsObject(this, keySignedOriginalDelta)) : null;
  }

  @Override
  public void setSignedOriginalDelta(ProtocolSignedDelta model) {
    setPropertyAsObject(this, keySignedOriginalDelta, (ProtocolSignedDeltaJsoImpl) model);
  }

  @Override
  public boolean hasHashedVersionAppliedAt() {
    return hasProperty(this, keyHashedVersionAppliedAt);
  }

  @Override
  public void clearHashedVersionAppliedAt() {
    if (hasProperty(this, keyHashedVersionAppliedAt)) {
      deleteProperty(this, keyHashedVersionAppliedAt);
    }
  }

  @Override
  public ProtocolHashedVersion getHashedVersionAppliedAt() {
    return hasProperty(this, keyHashedVersionAppliedAt) ? ((ProtocolHashedVersionJsoImpl) getPropertyAsObject(this, keyHashedVersionAppliedAt)) : null;
  }

  @Override
  public void setHashedVersionAppliedAt(ProtocolHashedVersion model) {
    setPropertyAsObject(this, keyHashedVersionAppliedAt, (ProtocolHashedVersionJsoImpl) model);
  }

  @Override
  public int getOperationsApplied() {
    return hasProperty(this, keyOperationsApplied) ? getPropertyAsInteger(this, keyOperationsApplied) : 0;
  }

  @Override
  public void setOperationsApplied(int value) {
    setPropertyAsInteger(this, keyOperationsApplied, value);
  }

  @Override
  public double getApplicationTimestamp() {
    return hasProperty(this, keyApplicationTimestamp) ? getPropertyAsDouble(this, keyApplicationTimestamp) : 0L;
  }

  @Override
  public void setApplicationTimestamp(double value) {
    setPropertyAsDouble(this, keyApplicationTimestamp, value);
  }

  @Override
  public boolean isEqualTo(Object o) {
    if (o instanceof ProtocolAppliedWaveletDeltaJsoImpl) {
      return nativeIsEqualTo(o);
    } else if (o instanceof ProtocolAppliedWaveletDelta) {
      return ProtocolAppliedWaveletDeltaUtil.isEqual(this, (ProtocolAppliedWaveletDelta) o);
    } else {
      return false;
    }
  }

}